Subject: Re: Considering teaching plumbing to users harmful

From: Jakub Narebski <[email-masked]>
Date: Thu, 17 Jul 2008 08:52:22 -0700 (PDT)

David Kastrup <[email-masked]> writes:

> Daniel Barkalow <[email-masked]> writes:

> > You're simply wrong. A ref isn't a name for a commit (the point of
> > having a ref is that it doesn't persist in naming the same commit). A
> > commit isn't a blob. If you start telling people complicated and wrong
> > things, they're surely going to be confused.

A ref is a pointer.  In the case of branches it is named pointer
to a commit, "tip of growth" of a branch (to stay with analogy from
biology).

> > Git maintains history as a directed graph, with each commit pointing
> > back at its history. Refs are the what holds the newest commits that
> > nothing else points back to. If directed graphs aren't in your users'
> > experience, you can put it this way: git maintains history like
> > knitting, where each new stitch holds on to one or more previous
> > stitches, and refs are the knitting needles that hold the ends where
> > you're working (except that knitting is a lot wider than software
> > development). gitk --all even provides the diagram you want to explain
> > it.
>
> Complicated and right things are not much less confusing...
 
For me the idea that commits contain pointers to state of repository
(state of project) at given "time" and pointers to its parents, and
those make history simple yet powerfull one.

Nevertheless simple ideas not always are easily to explain...

> > SVN branches are incredible confusing because they fail to distinguish
> > the directory structure of the project's source tree from the
> > arrangement of available latest versions.
> 
> That is because there _is_ no difference.  You just store different
> versions in different places.  What they are named is a convention,
> nothing more, nothing less.

Branching by copying (!) and tagging by copying (!!!) is abuse
of the fact that copying in Subversion is cheap.  Distinguishing
between branch part of directory name by _convention_ is design
mistake; the fact that the tool doesn't help to ensure that
(a) tags lie on branch (b) tags _doesn't change_ is an example
of this stupidity.
 
> > And the version numbers for your branch increase when changes are made
> > to other branches.
> 
> You are confusing "version numbers" which are assigned by humans with
> "revision numbers" which are just an administrational timeline for the
> whole repository.
> 
> Really, Subversion is rather simple to understand.  But it is not a
> DVCS.  Moving a history from one repository to another is not really
> feasible unless you are doing straight mirroring.

Subversion is simple if you are limited to simple things; but the
same is true with Git.  I find for example the whole 'properties'
mechanism and its use seriously not simple.

-- 
Jakub Narebski
Poland
ShadeHawk on #git